
/*
 Programmed by Christof Ermer
 https://homepages.uni-regensburg.de/~erc24492/
Christof Ermer 
Funktion: 

ORG Tiny2313(ohneA)  NEU
https://www.engbedded.com/fusecalc/
// F_CPU8000000UL / 8 = 1MHz

MERKE: BEI 1MHZ ist nur iene BAUDrate von 1200 möglich
ORG: FUSE: Low=62, High=DF
Dib Clk/8, SPI INt RC 4MHZ
WICHTIG !! STELLE LOW auf 0xD4 um, dann sind es 8MHZ/8


Microchip Studio USBasp Einstellung
AtTiny2313_HEX_to_USBsp
Arguments:
-patmega328p -Pcom8 -b115200 -U flash:w:"$(ProjectDir)Release\$(TargetName).hex":a -CC:\AVRDUDE\avrdude.conf -B 8.0 -v
-pt2313 -Pusb -cusbasp -CC:\AVRDUDE\avrdude.conf -U flash:w:"$(ProjectDir)Release\$(TargetName).hex":a -B 100 -v


"C:\AVRDUDE\avrdude.conf"
Initial direcory: $(ProjectDir)
Hacken setzen bei "Use Output window"


AVRDUDE options:
https://www.nongnu.org/avrdude/user-manual/avrdude_3.html

AVR LIB C
https://onlinedocs.microchip.com/pr/GUID-317042D4-BCCE-4065-BB05-AC4312DBC2C4-en-US-2/index.html?GUID-C7327199-4E9F-4A43-ABA2-2A7317E560AA


Bibliothek: file:///C:/WinAVR-20100110/doc/avr-libc/avr-libc-user-manual/modules.html
Controller Defines, File Explorer: C:\WinAVR-20100110\avr\include\avr\iom328p.h
int8_t uint8_t int16_t uint16_t int32_t uint32_t ISR main
https://github.com/SpenceKonde/ATTinyCore
http://drazzy.com/package_drazzy.com_index.json

https://wolles-elektronikkiste.de/attiny-mit-arduino-code-programmieren
http://drazzy.com/package_drazzy.com_index.json

https://github.com/arduino/Arduino/wiki/Unofficial-list-of-3rd-party-boards-support-urls
http://www.leonardomiliani.com/repository/package_leonardomiliani.com_index.json
*/

/*
 * ATTiny2313_1.c
 *
 * Created: 30.11.2023 15:16:05
 * Author : Christof
 */ 
//In Symbols:  F_CPU=1000000UL
/*
Project->CustomOptions in dem Eingabefeld, links neben dem Button "Add"
die Möglichkeit Deine Definition "-DF_CPU 16000000UL" einzugeben
*/

//SYSINFO
#define SOFTWARE "3xRelais"
#define DATUM "30.01.2024"
#define AUTOR "* Christof Ermer *"
#define HARDWARE "ATtiny2313"
// ============================================
#include <stdint.h>
#include <ctype.h>
#include <inttypes.h>
#include <avr/io.h>
#include <string.h>
#include <stdlib.h>
#include <avr/pgmspace.h>
#include <math.h>
#include <avr/interrupt.h>
#include <avr/wdt.h>

#include <util/delay.h>

//extern "C" {  // ohne dies, reference Linker Fehler
#include "main.h"
//#include "debug.h"
#include "uart328.h"
#include "TextService.h"
#include "Befehle.h"
//};  //extern

// ============================================
// Globale Variablen
volatile uint32_t gu32Ticks;
volatile BIT_FIELD_TYPE gstFlags;

// *******************
ISR(TIMER0_COMPA_vect)  //1000Hz = 1mS
// *******************
{
	gu32Ticks++;                      // ~250/Sekunde
	if (!(gu32Ticks % TICKS_1000MS))  //Modulo ==0 ?
	{
		gstFlags.TickEvent_Flag = 1;  //Set FLAG
	};
	
	if (!(gu32Ticks & 0x15) )  //Modulo n-1 ?
	{
	UART_RX_Check();
	};

};

// *****************************
void StartTickTimer(void)  // Mllisekunden
// *****************************
{  // Timer0 TickCounter starten im Compare Mode
  //8MHU / 8 / 125
  TCNT0 = 0;
  OCR0A = 125;                         //Compare Value
  TCCR0A = (1 << WGM01);               //CTC Mode = Compare Timer Counter mit OCR0A
  TIMSK = (1 << OCIE0A);              //Compare Interrupt aktivieren
  TCCR0B = (1 << CS01 );  //Vorteiler /8 =  1000*/sec
};


// *****************
int main(void)
// *****************
{
	//uint8_t u8NN=0;
	RELAIS_INIT();
	RELAIS_ALL_OFF();
	OPEN_COL_1INIT();
	OPEN_COL_2INIT();
	AUX_PORT_INIT();
	BLINK_ON();
	
  uart_init(UART_BAUD_SELECT(1200, F_CPU));
  //uart_init(UART_BAUD_SELECT(9600, 1000000UL));  //Stelle Fuse Low=0xD4
  ResetRxBuff();
    	
  StartTickTimer();

  wdt_reset();
  wdt_enable(WDTO_2S);  //Totmannknopf
  wdt_reset();
  
  sei();  //Es sei! Interrupt einschalten
  
  REL1_ON();  
  gstFlags.Traffic_Flag = 1;
  uart_puts_p( PSTR("3xRelais\r\n") );
  
  while (42) /* loop forever */
  {
    wdt_reset();
    //Toggle_Bit( 1 );
    if (gstFlags.TickEvent_Flag)  // ?-->1
    {
    gstFlags.TickEvent_Flag = 0;  // clear Flag	  	  
	BLINK_TOGGLE();
	if( gstFlags.Traffic_Flag )
		{	
		uart_puts( ULongToNumStr(gu32Ticks) );
		TxCRLF();
		};			
					
//uart_puts( ULongToNumStr(gu32Ticks) );
//uart_putc(13);a
//uart_putc(10);
    };

    if (gsCmd.UartCREventFlag)  // bearbeite Carriage Return Order
    {
      CheckOrder();
      ResetRxBuff();
      gsCmd.UartCREventFlag = 0;
    };
  };  //while
};
// ******** MAIN END ********
